#include "needles.h"
//In this class, we have many functions, which represent all elements in the electrical system.
//Every function calls another function into oblivion.
Electricity::Electricity(VESSEL3 * v) : v(v){
	
}
Electricity::~Electricity() {
	
}
void Electricity::update(vesselstate vs) {
	thing = vs;
}
double Electricity::GetVoltageMNA() {
	return MNA() * 40 / (1 + GetLoadMNA() / maxloadMNA);
}
double Electricity::GetVoltageMNB() {
	return MNB() * 40 / (1 + GetLoadMNB() / maxloadMNB);
}
double Electricity::GetAmpereMNA() {
	return (GetVoltageMNA() > 0) ? MNA()* GetLoadMNA() / GetVoltageMNA() : 0;
}
double Electricity::GetAmpereMNB() {
	return (GetVoltageMNB() > 0) ? MNB() * GetLoadMNB() / GetVoltageMNB() : 0;
}
double Electricity::GetLoadMNA() {
	return (IMULoadMNA() + ADPLoadMNA() + RADLoadMNA() + RDRLoadMNA() + MAINLoadMNA() + HVRLoadMNA());
}
double Electricity::GetLoadMNB() {
	return (IMULoadMNB() + ADPLoadMNB() + RADLoadMNB() + RDRLoadMNB() + MAINLoadMNA() + HVRLoadMNA());
}
double Electricity::GetLoadBAT1() {
	return thing.MNA_b1b2* GetLoadMNA() + thing.MNB_b1b2* GetLoadMNB();
}
double Electricity::GetLoadBAT2() {
	return !thing.MNA_b1b2 * GetLoadMNA() + !thing.MNB_b1b2 * GetLoadMNB();
}
bool Electricity::MNAb1b2() {
	if (thing.MNA_b1b2 && !thing.BATT1_d) {
		return thing.BATT1;
	} else if(!thing.MNA_b1b2 && !thing.BATT1_d) { return thing.BATT2;} else { return false; }
}
bool Electricity::MNBb1b2() {
	if (thing.MNB_b1b2 && !thing.BATT1_d) {
		return thing.BATT1;
	}
	else if (!thing.MNB_b1b2 && !thing.BATT1_d) { return thing.BATT2; }
	else { return false; }
}
bool Electricity::MNA() {
	if (thing.MNA && !thing.MNA_d) {
		return MNAb1b2();
	}
	else { return false; }
}
bool Electricity::MNB() {
	return (thing.MNB && !thing.MNB_d) ? MNBb1b2() : false;
}
double DrawPower(double W, bool b) {
		return b ? W : (2 * W);
}
bool Electricity::IMU() {
		return !thing.IMU_d && thing.IMU_p && ((thing.IMU_MNA && MNA()) || (thing.IMU_MNB && MNB()));
}
bool Electricity::RADAR() {
		return BetterPB.radar && ((thing.RDR_MNA && MNA()) || (thing.RDR_MNB && MNB()));
}
bool Electricity::ADP() {
	return ((thing.ADP_MNA && MNA()) || (thing.ADP_MNB && MNB()));
}
bool Electricity::RADIO() {
	return BetterPB.radio && ((thing.RAD_MNA && MNA()) || (thing.RAD_MNB && MNB()));
}
double Electricity::IMULoadMNA() {
	return DrawPower(50, (thing.IMU_MNB && MNB())) * (thing.IMU_MNA && MNA())*IMU();
}
double Electricity::ADPLoadMNA() {
	return DrawPower(15, (thing.ADP_MNB && MNB())) * (thing.ADP_MNA && MNA()) * ADP();
}
double Electricity::IMULoadMNB() {
	return DrawPower(50, (thing.IMU_MNA && MNA())) * (thing.IMU_MNB && MNB()) * IMU();
}
double Electricity::ADPLoadMNB() {
	return DrawPower(15, (thing.ADP_MNA && MNA())) * (thing.ADP_MNB && MNB()) * ADP();
}
double Electricity::RADLoadMNA() {
	return DrawPower(100, (thing.RAD_MNB && MNB())) * (thing.RAD_MNA && MNA()) * BetterPB.radio;
}
double Electricity::RADLoadMNB() {
	return DrawPower(100, (thing.RAD_MNA && MNA())) * (thing.RAD_MNB && MNB()) * BetterPB.radio;
}
double Electricity::RDRLoadMNA() {
	return DrawPower(60, (thing.RDR_MNB && MNB())) * (thing.RDR_MNA && MNA()) * BetterPB.radar;
}
double Electricity::RDRLoadMNB() {
	return DrawPower(60, (thing.RDR_MNA && MNA())) * (thing.RDR_MNB && MNB()) * BetterPB.radar;
}
double Electricity::MAINLoadMNA() {
	return (v->GetThrusterGroupLevel(THGROUP_MAIN) > 0) ? DrawPower(150, MNB()) : 0; //if the thruster is on draw 150 W, otherwise, don't
}
double Electricity::MAINLoadMNB() {
	return (v->GetThrusterGroupLevel(THGROUP_MAIN) > 0) ? DrawPower(150, MNA()) : 0;
}
double Electricity::HVRLoadMNA() {
	return (v->GetThrusterGroupLevel(THGROUP_HOVER) > 0) ? DrawPower(150, MNB()) : 0;
}
double Electricity::HVRLoadMNB() {
	return (v->GetThrusterGroupLevel(THGROUP_HOVER) > 0) ? DrawPower(150, MNA()) : 0;
}
