#include "Orbitersdk.h"
inline float Madrixx(float t, float vectorz[], float ofs[])//It'll do rotation for me, so it'll be more simple! 
{
	return cos(t) * (vectorz[0] - ofs[0]) - sin(t) * (vectorz[1] - ofs[1]) + ofs[0];
}
inline float Madrixy(float t, float vectorz[], float ofs[])//It will also simplify.
{
	return (sin(t) * (vectorz[0] - ofs[0]) + cos(t) * (vectorz[1] - ofs[1]) + ofs[1]);
}
class Needle {
public:
	Needle(int x, int y);
	~Needle();
	void Init(MESHHANDLE hMesh, DWORD grpidx);
	void Redraw(double level);
protected:
	int X=0, Y=0;
	int vofs = 0;
	MESHGROUP* grp = NULL;
};
struct vesselstate {
	//_l = level
	//_p = panel
	//_d = damage

	//levels
	double batt1 = 400; //kWh
	double batt2 = 400;//kWh
	int scale = 5;
	double ThrottleM = 0;
	double ThrottleH = 0;
	double ADRext_l = 0;
	double ADLext_l = 0;
	//CB
	bool BATT1 = true;
	bool BATT2 = true;
	bool MNA = true;
	bool MNB = true;
	bool IMU_MNA = true;
	bool IMU_MNB = true;
	bool ADP_MNA = true;
	bool ADP_MNB = true;
	bool RAD_MNA = true;
	bool RAD_MNB = true;
	bool RDR_MNA = true;
	bool RDR_MNB = true;
	//switches
	bool ADLext_p = false;
	bool ADRext_p = false;
	bool radar = true;
	bool radio = true;
	bool main_arm = true;
	bool hvr_arm = true;
	int rcs = 1;
	int adimode = 1;
	bool MNA_b1b2 = true;
	bool MNB_b1b2 = true;
	bool IMU_p = true;
	int af = 1;
	//true state of the vessel
	bool ded = false;
	bool ADLext = false;
	bool ADRext = false;
	bool IMU = true;
	bool RADAR = true;
	//damages
	bool IMU_d = false;
	bool BATT1_d = false;
	bool BATT2_d = false;
	bool MNA_d = false;
	bool MNB_d = false;
	bool IMU_MNA_d = false;
	bool IMU_MNB_d = false;
	bool ADP_MNA_d = false;
	bool ADP_MNB_d = false;
	bool ADLext_d = false;
	bool ADRext_d = false;
};
extern vesselstate BetterPB;
class Electricity {
public:
	Electricity(VESSEL3 * v); //approved for 2*750W
	~Electricity();
	void update(vesselstate vs);
	bool MNAb1b2();
	bool MNBb1b2();
	bool MNA();
	bool MNB();
	bool IMU();
	bool RADAR();
	bool RADIO();
	bool ADP();
	double GetVoltageMNA();
	double GetVoltageMNB();
	double GetAmpereMNA();
	double GetAmpereMNB();
	double GetLoadMNA();
	double GetLoadMNB();
	double IMULoadMNA(); 
	double ADPLoadMNA();
	double IMULoadMNB();
	double ADPLoadMNB();
	double RADLoadMNA();
	double RADLoadMNB();
	double RDRLoadMNA();
	double RDRLoadMNB();
	double GetLoadBAT1();
	double GetLoadBAT2();
	double MAINLoadMNA();
	double MAINLoadMNB();
	double HVRLoadMNA();
	double HVRLoadMNB();
protected:
	vesselstate thing;
	VESSEL3 * v;
	double maxloadMNA = 1500;
	double maxloadMNB = 1500;
};